/******************************************************************************
*******************************************************************************

	GLfont
	relminator (Richard Eric M. Lope BSN RN)
	http://rel.betterwebber.com


	main() entry point
	
	
 
*******************************************************************************
******************************************************************************/


#include <nds.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "Cglsprite.h"
#include "Cgl2d.h"
#include "Cglfont.h"


// GRIT headers
#include "main_sprites.h"
#include "font_16x16.h"
#include "font_si.h"

// Texture packer headers
#include "uvcoord_main_sprites.h"
#include "uvcoord_font_16x16.h"
#include "uvcoord_font_si.h"


/******************************************************************************
*******************************************************************************
	MAIN entry point


*******************************************************************************
******************************************************************************/



void init_gl_screen();

Cglsprite main_sprites[MAIN_SPRITES_NUM_IMAGES];	//  number of frames
Cglsprite font_16x16_sprites[FONT_16X16_NUM_IMAGES];		//  number of frames
Cglsprite font_si_sprites[FONT_16X16_NUM_IMAGES];		//  number of frames


Cgl2d gl2d;

Cglfont font_16x16;
Cglfont font_si;

int main(int argc, char *argv[])
{

	
	
	font_16x16.init(font_16x16_sprites);
	font_si.init(font_si_sprites);
	
	videoSetMode(MODE_5_3D);
	
	
	consoleDemoInit();
	
	iprintf("\x1b[1;1HGL font DS");
	iprintf("\x1b[2;1HRelminator");
	iprintf("\x1b[3;1Hhttp://rel.betterwebber.com");
	
	iprintf("\x1b[5;1HPress 'A' to reset movement");
	
	
	init_gl_screen();
	
	
	vramSetBankA(VRAM_A_TEXTURE);		// 128 kb -> main_sprites(64kb) and enemies(64kb) 
	
	// main sprites
	int main_sprites_textureID;  
	gl2d.load_texture(main_sprites_textureID,GL_RGB256, TEXTURE_SIZE_256 , TEXTURE_SIZE_256, (u8*)main_spritesBitmap);

	int font_16x16_sprites_textureID;  
	gl2d.load_texture(font_16x16_sprites_textureID,GL_RGB256, TEXTURE_SIZE_64 , TEXTURE_SIZE_512, (u8*)font_16x16Bitmap);

	int font_si_sprites_textureID;  
	gl2d.load_texture(font_si_sprites_textureID,GL_RGB256, TEXTURE_SIZE_64 , TEXTURE_SIZE_128, (u8*)font_siBitmap);

	// load global pal
	// texture pal in VRAM_E?
	gluTexLoadPal(main_spritesPal, 512,GL_RGB256);

		
	// init sprites
	gl2d.init_sprites(main_sprites, MAIN_SPRITES_NUM_IMAGES, main_sprites_texcoords, main_sprites_textureID);
	
	// init sprites
	gl2d.init_sprites(font_16x16_sprites, FONT_16X16_NUM_IMAGES, font_16x16_texcoords, font_16x16_sprites_textureID);
	
	// init sprites
	gl2d.init_sprites(font_si_sprites, FONT_SI_NUM_IMAGES, font_si_texcoords, font_si_sprites_textureID);
	
	int total_frame = 0;
	int start_frame = 54;
	int frame_counter = 0;
	
	s32 spacing = 5 << 12;
	s32 x = 200 << 12;
	s32 angle = 0;
	s32 radius = 50 << 12;
	int keys;
	
	while(1)
	{
	
		if (radius > 0)
			radius -= 512;
			
		angle += 256;
		scanKeys();
		keys = keysDown();
		
		if(keys & KEY_A)
		{
			spacing = 5 << 12;
			x = 200 << 12;
			radius = 50 << 12;
		}
		
		if (spacing > 0)
			spacing -= 256;
		
		if (x > (0 << 12))
			x -= floattof32(2.5);
			
		total_frame++;
		
		if (total_frame & 1)
		{
			start_frame = 54;
			frame_counter++;
		}
		else
		{
			start_frame = 80;
		}
	
		// start 2d mode
		gl2d.start();
			
			
			
			// needs to be called before texturing
			// or sprite gets blended by last glcolor call
			glColor(ARGB16(1,31,31,31)); 
			
			gl2d.increase_depth();
			
			main_sprites[start_frame+(frame_counter & 3)].stretch_h(10, 160, 100);
			
			
			font_si.print(10, 0, "ANYA THERESE");
			
			font_si.print(10, 20, total_frame);
			
			font_16x16.print_score(10, 40, total_frame, "0",7);
			
			font_16x16.print_centered(10, 60, "ANYA");
			font_16x16.print_centered(10, 80, total_frame);
			
			gl2d.increase_depth();
			
			font_si.print_sine(10, 140, "RELMINATOR", 4, radius >> 12, -2, angle);
			font_si.print_sine(10, 140, "RELMINATOR", 4, radius >> 12, 1, angle+32768/4);

			font_si.print_sine_vertical(200, 10, "RELMINATOR", 2, radius >> 12, 2, angle);

			gl2d.increase_depth();
			
			font_si.print_spaced(x >> 12, 100, "ANYA THERESE", 0, -spacing, -spacing);
			font_si.print_spaced(x >> 12, 100, "ANYA THERESE", 0, spacing, -spacing);
			font_si.print_spaced(x >> 12, 100, "ANYA THERESE", 0, -spacing, spacing);
			font_si.print_spaced(x >> 12, 100, "ANYA THERESE", 0, spacing, spacing);
			font_si.print_spaced(x >> 12, 100, "ANYA THERESE", 0, spacing, 0);
			
			gl2d.increase_depth();
			
			
			font_16x16.print_spaced_vertical(220, x >> 12, "ANYA THERESE", 0, -spacing, -spacing);
			font_16x16.print_spaced_vertical(220, x >> 12, "ANYA THERESE", 0, spacing, -spacing);
			font_16x16.print_spaced_vertical(220, x >> 12, "ANYA THERESE", 0, -spacing, spacing);
			font_16x16.print_spaced_vertical(220, x >> 12, "ANYA THERESE", 0, spacing, spacing);
			font_16x16.print_spaced_vertical(220, x >> 12, "ANYA THERESE", 0, 0, spacing);
			
		gl2d.end();
		
		
		
		
	
		glFlush(0);

		swiWaitForVBlank();
		
	}

	
	return 0;
	
}



void init_gl_screen()
{

	// initialize gl
	glInit();
	
	//enable textures
	glEnable(GL_TEXTURE_2D);
	
	// enable antialiasing
	glEnable(GL_ANTIALIAS);
		
	// setup the rear plane
	glClearColor(0,0,0,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	
	glClearDepth(GL_MAX_DEPTH);

	//this should work the same as the normal gl call
	glViewport(0,0,255,191);
	
	
	//any floating point gl call is being converted to fixed prior to being implemented
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70, 256.0 / 192.0, 1, 200);
	
	gluLookAt(	0.0, 0.0, 1.0,		//camera possition 
				0.0, 0.0, 0.0,		//look at
				0.0, 1.0, 0.0);		//up

	glMaterialf(GL_AMBIENT, RGB15(31,31,31));
	glMaterialf(GL_DIFFUSE, RGB15(31,31,31));
	glMaterialf(GL_SPECULAR, BIT(15) | RGB15(31,31,31));
	glMaterialf(GL_EMISSION, RGB15(31,31,31));

	//ds uses a table for shinyness..this generates a half-ass one
	glMaterialShinyness();

	//not a real gl function and will likely change
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK);
}

